unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask, DBCtrls, ExtCtrls, DBCoords, DB, DBTables,
  Buttons, About, Rzlabel;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Places: TTable;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    Panel3: TPanel;
    DBEdit1: TDBEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    RzLabel1: TRzLabel;
    ModeIndicator: TLabel;
    DBCoords1: TDBCoords;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure DataSource1StateChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

const
  DatasetStates: array[TDataSetState] of string[11] =
    ('Not active', 'Browsing', 'Editing', 'Inserting',
    'Setting key', 'Calculating');

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Places.Close;
  Places.DatabaseName := ExtractFilePath(Application.ExeName);
  Places.TableName := 'PLACES.DBF';
  Places.Open;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Places.Close;
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.DataSource1StateChange(Sender: TObject);
begin
  {update state caption}
  if DataSource1.Dataset <> nil then ModeIndicator.Caption :=
    Format('[%S: %S]', [DataSource1.Dataset.Name, DatasetStates[DataSource1.State]]);
  if DataSource1.State in [dsEdit, dsInsert] then
    ModeIndicator.Font.Color := clRed
  else
    ModeIndicator.Font.Color := clBlue;
end;

end.
